#
# first2.mak
#
# A not so elementary makefile. Does the same thing as makefile.mak

# --- Project details ---
PROJ= first

# --- boot type ---
MB = 1
ifeq ($(MB),1)
EXT     := mb.gba
SPECS   := -specs=gba_mb.specs
else
EXT     := gba
SPECS   := -specs=gba.specs
endif

# --- Compiling ---
CROSS   ?= arm-eabi-
AS      := $(CROSS)as
CC      := $(CROSS)gcc
LD      := $(CROSS)gcc
OBJCOPY := $(CROSS)objcopy

ARCH   := -mthumb-interwork -mthumb

ASFLAGS := -mthumb-interwork
CFLAGS  := $(ARCH) -O2 -Wall
LDFLAGS := $(ARCH) $(SPECS)

# --- Build ---
.PHONY : build
build: 
	$(CC) first.c -c 
	$(CC) first.o $(LDFLAGS) -o $(PROJ).elf
	$(OBJCOPY) -v -O binary $(PROJ).elf $(PROJ).$(EXT)
	-@gbafix $@ -t$(TITLE)

# --- Clean ---
.PHONY : clean
clean : 
	@rm -fv first.o
	@rm -fv $(PROJ).elf
	@rm -fv $(PROJ).$(EXT)

#EOF
